global gStoredTime, gPreviousTime, gAutomatedTimes, gWhichAutomatedClip, gATC, gWhichCamera, gMovieSprite, gWhichMovie, gWhichClip, gStartTime, gStopTime, gRecording, gPlaying

on storeAndGo randomTimeCode
  advanceNewFrame()
  set timeCodes to EMPTY
  do("set timeCodes=getAt (gMovie" & gWhichMovie & "TimeCodes, gWhichClip)")
  set gStartTime1 to getAt(timeCodes, 1) + 12
  set gStopTime1 to getAt(timeCodes, 2) - 30
  set gStartTime2 to getAt(timeCodes, 3) + 12
  set gStopTime2 to getAt(timeCodes, 4) - 30
  if randomTimeCode = 1 then
    if gWhichCamera = "A" then
      set gStartTime to gStartTime1
      set gStopTime to gStopTime1
    else
      set gStartTime to gStartTime2
      set gStopTime to gStopTime2
    end if
  else
    set gStartTime to gStartTime1
    set gStopTime to gStopTime1
  end if
  storeStartTime(gStartTime)
  cursor(4)
end

on resetTime
  set gPreviousTime to gStoredTime
  set gStoredTime to []
end

on storeTimes
  storeStopTime(the movieTime of sprite gMovieSprite)
  storeStartTime(gStartTime)
end

on storeTimes2
  set timeCodes to EMPTY
  do("set timeCodes=getAt (gMovie" & gWhichMovie & "TimeCodes, gWhichClip)")
  set gStartTime1 to getAt(timeCodes, 1) + 12
  set gStopTime1 to getAt(timeCodes, 2) - 30
  set gStartTime2 to getAt(timeCodes, 3) + 12
  set gStopTime2 to getAt(timeCodes, 4) - 30
  storeStopTime(the movieTime of sprite gMovieSprite)
  storeStartTime(gStartTime1)
end

on restoreTime
  set gStoredTime to gPreviousTime
end

on storeStartTime whichTime
  if gRecording = 1 then
    if voidp(whichTime) then
      set whichTime to gStartTime
    end if
    if the type of sprite gMovieSprite > 0 then
      set whichCast to the castNum of sprite gMovieSprite
      if whichCast > 0 then
        if the castType of cast whichCast = #digitalVideo then
          if whichTime = 0 then
            if gWhichClip <> 1 then
              put "Start: ", gWhichMovie, gWhichClip, whichTime, gStartTime
            end if
          end if
          set theCount to count(gStoredTime)
          if theCount > 0 then
            set setStart to getAt(gStoredTime, theCount)
            set setStart to getAt(setStart, 1)
            if not (setStart contains "Stop") then
              put "Starttime error: the previous item in gStoredTime is not a stop time."
              exit
            end if
          end if
        end if
        append(gStoredTime, ["Start: ", gWhichMovie, gWhichClip, whichTime])
        set the text of cast "timeCodes" to string(gStoredTime)
      end if
    end if
  end if
end

on storeStopTime whichTime
  if voidp(whichTime) then
    set whichTime to gStopTime
  end if
  if the type of sprite gMovieSprite > 0 then
    set whichCast to the castNum of sprite gMovieSprite
    if whichCast > 0 then
      if the castType of cast whichCast = #digitalVideo then
        set theCount to count(gStoredTime)
        if theCount > 0 then
          set setStop to getAt(gStoredTime, count(gStoredTime))
          set setStop to getAt(setStop, 1)
          if not (setStop contains "Start") then
            if gRecording = 1 then
              put "Stoptime error: the previous item in gStoredTime is not a start time."
            end if
            exit
          end if
        end if
      end if
      append(gStoredTime, ["Stop: ", gWhichMovie, gWhichClip, whichTime])
      set the text of cast "timeCodes" to string(gStoredTime)
    end if
  end if
end

on sortTimeCodes
  set adjustedTimeCodes to []
  set checkCode to 0
  repeat with x = 1 to count(gStoredTime) - 1
    set itemX to getAt(gStoredTime, x)
    set itemX.1 to getAt(gStoredTime, x + 1)
    if getAt(itemX, 1) contains "Start" then
      if getAt(itemX.1, 1) contains "Stop" then
        set whichMovie to getAt(itemX, 2)
        if getAt(itemX.1, 2) = whichMovie then
          set whichClip to getAt(itemX, 3)
          if getAt(itemX.1, 3) = whichClip then
            set startTime to getAt(itemX, 4)
            set stopTime to getAt(itemX.1, 4)
            set timeCodes to EMPTY
            do("set timeCodes=getAt (gMovie" & whichMovie & "TimeCodes, whichClip)")
            set startTime1 to getAt(timeCodes, 1)
            set stopTime1 to getAt(timeCodes, 2)
            set startTime2 to getAt(timeCodes, 3)
            set stopTime2 to getAt(timeCodes, 4)
            if startTime <= stopTime then
              if stopTime <= stopTime1 then
                append(adjustedTimeCodes, [whichMovie, whichClip, "A", startTime, stopTime])
                set checkCode to checkCode - startTime + stopTime
              else
                if startTime >= startTime2 then
                  append(adjustedTimeCodes, [whichMovie, whichClip, "B", startTime, stopTime])
                  set checkCode to checkCode - startTime + stopTime
                else
                  nothing()
                end if
              end if
              next repeat
            end if
            if startTime <= stopTime1 then
              if stopTime <= stopTime1 then
                append(adjustedTimeCodes, [whichMovie, whichClip, "A", startTime, stopTime1])
                append(adjustedTimeCodes, [whichMovie, whichClip, "A", startTime1, stopTime])
                set checkCode to checkCode - startTime + stopTime1 - startTime1 + stopTime
              else
                nothing()
              end if
            else
              if startTime >= startTime2 then
                if stopTime >= startTime2 then
                  append(adjustedTimeCodes, [whichMovie, whichClip, "B", startTime, stopTime2])
                  append(adjustedTimeCodes, [whichMovie, whichClip, "B", startTime2, stopTime])
                  set checkCode to checkCode - startTime + stopTime2 - startTime2 + stopTime
                else
                  nothing()
                end if
              else
                nothing()
              end if
            end if
            set x to x + 1
          end if
        end if
      end if
    end if
  end repeat
  if count(adjustedTimeCodes) > 0 then
    append(adjustedTimeCodes, checkCode)
    set gATC to adjustedTimeCodes
  end if
  return adjustedTimeCodes
end

on checkTimeCodes adjustedTimeCodes
  if listp(adjustedTimeCodes) = 0 then
    return 0
  end if
  if count(adjustedTimeCodes) = 0 then
    return 0
  end if
  set checkCode to value(getAt(adjustedTimeCodes, count(adjustedTimeCodes)))
  set checkTotal to 0
  repeat with x = 1 to count(adjustedTimeCodes) - 1
    set timeCodeX to getAt(adjustedTimeCodes, x)
    set checkTotal to checkTotal - getAt(timeCodeX, 4) + getAt(timeCodeX, 5)
  end repeat
  if checkTotal = checkCode then
    set gAutomatedTimes to adjustedTimeCodes
    set gWhichAutomatedClip to 1
    return 1
  else
    alert("This is an invalid data file." & RETURN & RETURN & "Please select another.")
    return 0
  end if
end
