global gAutoInUse, gOldMovie, gWhichMovie, gOldClip, gWhichClip, gVR, gMarkers, gMovieSprite, gWhichCamera, gPanoMovieID, gReturning, gFloatingSprite, gAutomated, gRecording, gPlaying, gStaring, gMoviePauseState, gFullScreen, gSliderSprite, gCode, gWeapon, gOldWhichMovie, gOldWhichClip, gLoadedTimeCodes, gDontMessWithTheSlider, gStopTime, gStartTime, gDontReturnTo0, gVR.NodeID, gVR.HPanAngle, gVR.VPanAngle, gVR.ZoomAngle, gVR.Quality

on cameraBoolean
  if gFullScreen = 0 then
    if gAutomated = 0 then
      if gAutoInUse = 0 then
        return 1
        exit
      end if
    end if
  end if
  return 0
end

on updateCamera
  puppetSprite(gFloatingSprite, 1)
  removeFloating()
  if cameraBoolean() = 1 then
    if gVR = 0 then
      activate(3, "typeA", 1, 0, 463, 239, EMPTY, EMPTY, EMPTY)
      activate(4, "typeB", 1, 0, 574, 242, EMPTY, EMPTY, EMPTY)
      if gWhichCamera = "A" then
        activate(gFloatingSprite, "typeA!", 1, 0, 463, 239, EMPTY, EMPTY, EMPTY)
      else
        activate(gFloatingSprite, "typeB!", 1, 0, 574, 242, EMPTY, EMPTY, EMPTY)
      end if
    else
      activate(3, "typeA.vr", 1, 0, 465, 241, EMPTY, EMPTY, EMPTY)
      activate(4, "typeB.vr", 1, 0, 576, 244, EMPTY, EMPTY, EMPTY)
      if gWhichCamera = "A" then
        activate(gFloatingSprite, "typeA.vr!", 1, 0, 465, 241, EMPTY, EMPTY, EMPTY)
      else
        activate(gFloatingSprite, "typeB.vr!", 1, 0, 576, 244, EMPTY, EMPTY, EMPTY)
      end if
    end if
    setProp(3, 4, "visibility", 1)
    set the visible of sprite gFloatingSprite to 1
  else
    setProp(3, 4, "visibility", 0)
    set the visible of sprite gFloatingSprite to 0
  end if
  updateStage()
end

on removeFloating
  set the locV of sprite gFloatingSprite to -500
  updateStage()
  deactivate([gFloatingSprite])
  set the visible of sprite gFloatingSprite to 0
  updateStage()
end

on legalButton whichSprite, maintainScript
  repeat while the mouseDown
    nothing()
  end repeat
  if maintainScript <> 1 then
    set the timeoutScript to "nothing"
  end if
  return 1
end

on selectGirl whichSprite
  restoreControl()
  set gAutomated to 0
  flashQD(whichSprite)
  set whichGirl to whichSprite - 17
  set gOldMovie to gWhichMovie
  set gWhichMovie to whichGirl
  puppetSprite(gFloatingSprite, 1)
  set the visible of sprite 32 to 1
  puppetSprite(32, 0)
  puppetSprite(33, 0)
  puppetSprite(34, 0)
  set gStaring to 0
  advanceClip(1)
  updateCamera()
end

on selectClip whichSprite
  restoreControl()
  set gAutomated to 0
  flashQD(whichSprite)
  set whichClip to whichSprite - 23
  set the visible of sprite 32 to 1
  set gStaring to 0
  advanceClip(whichClip)
  updateCamera()
end

on selectCode whichSprite
  if voidp(gWeapon) then
    exit
  end if
  set whichCode to whichSprite - 26
  if voidp(gCode) then
    set gCode to []
  end if
  set the castNum of sprite 26 to the number of cast ("Code" & whichCode)
  updateStage()
  delayFor(10)
  append(gCode, whichCode)
  set theCount to count(gCode)
  if theCount < 5 then
    exit
  else
    if theCount > 5 then
      set newCode to [getAt(gCode, theCount - 4)]
      append(newCode, getAt(gCode, theCount - 3))
      append(newCode, getAt(gCode, theCount - 2))
      append(newCode, getAt(gCode, theCount - 1))
      append(newCode, getAt(gCode, theCount))
      set gCode to newCode
    end if
  end if
  if gWeapon = 1 then
    if gCode = [1, 3, 3, 2, 2] then
      set gWhichCamera to "A"
      setProp(23, 24, "visibility", 0)
      setProp(26, 29, "visibility", 0)
      go("vr.2")
      set gPlaying to 1
      exit
    end if
  else
    if gWeapon = 2 then
      if (gCode = [3, 1, 2, 1, 1]) or (gCode = [3, 3, 1, 2, 3]) then
        set gWhichCamera to "A"
        setProp(23, 24, "visibility", 0)
        setProp(26, 29, "visibility", 0)
        go("vr.3")
        set gPlaying to 1
        exit
      end if
    end if
  end if
  go("Access Denied")
end

on selectWeapon whichSprite
  sound stop 1
  sound stop 2
  if whichSprite = 23 then
    set gWeapon to 1
    set gWhichMovie to 2
    set the ink of sprite 23 to 4
    set the ink of sprite 24 to 0
  else
    set gWeapon to 2
    set gWhichMovie to 3
    set the ink of sprite 23 to 0
    set the ink of sprite 24 to 4
  end if
  updateStage()
  delayFor(10)
  set gCode to []
  go("Code" & whichSprite)
end

on flashQD whichSprite
  storeStopTime(the movieTime of sprite gMovieSprite)
  set gMoviePauseState to the movieRate of sprite gMovieSprite
  setProp(18, 21, "puppet", 0)
  setProp(24, 29, "puppet", 0)
  go(the frame)
  puppetSprite(whichSprite, 1)
  set the ink of sprite whichSprite to 4
  updateStage()
end

on delayFor howLong, interruptible
  set howLong to howLong + the timer
  repeat while the timer < howLong
    if interruptible = 1 then
      if developersKey() = 1 then
        exit repeat
      end if
      next repeat
    end if
    nothing()
  end repeat
end

on advanceMarker whichMarker
  if gVR = 0 then
    set whichMarker to whichMarker + 1
  else
    set whichMarker to whichMarker - 9
  end if
  set whichMarker to checkRange(whichMarker, 1, count(gMarkers))
  go(getAt(gMarkers, whichMarker))
end

on advanceClip whichClip
  set gWhichMovie to checkRange(gWhichMovie, 1, 4)
  set numberOfClips to 0
  do("set numberOfClips=value ( count ( gMovie" & gWhichMovie & "TimeCodes ))")
  set gWhichClip to checkRange(whichClip, 1, numberOfClips)
  cursor(4)
  storeAndGo()
  highlightSelection()
end

on randomClip
  set the movieRate of sprite gMovieSprite to 0
  updateStage()
  storeStopTime(the movieTime of sprite gMovieSprite)
  set gWhichMovie to random(4)
  set numberOfClips to 0
  do("set numberOfClips=value ( count ( gMovie" & gWhichMovie & "TimeCodes ))")
  set gOldClip to gWhichClip
  repeat while gOldClip = gWhichClip
    set gWhichClip to random(numberOfClips)
  end repeat
  if random(2) = 1 then
    set gWhichCamera to "A"
  else
    set gWhichCamera to "B"
  end if
  storeAndGo(1)
  set the timeoutLength to 240 + (random(5) * 60)
  set randomMovieTime to gStopTime - gStartTime - the timeoutLength - 60
  set randomMovieTime to checkRange(randomMovieTime, 1, randomMovieTime)
  set randomMovieTime to random(randomMovieTime) + gStartTime
  set randomMovieTime to checkRange(randomMovieTime, gStartTime, gStopTime - the timeoutLength)
  set the movieTime of sprite gMovieSprite to randomMovieTime
  set the timeoutLapsed to 0
  updateStage()
end

on restoreControl
  if gVR = 0 then
    if gAutoInUse = 1 then
      set the timeoutScript to "nothing"
      restore([3, 4, 11, 12, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38])
      setProp(3, 4, "puppet", 0)
      setProp(17, 29, "puppet", 0)
      set the loc of sprite 31 to point(219, 315)
      set the loc of sprite 32 to point(66, 315)
      set the loc of sprite 33 to point(94, 315)
      set the loc of sprite 34 to point(372, 315)
      set the loc of sprite 35 to point(122, 314)
      set the loc of sprite 36 to point(344, 314)
      set the loc of sprite 37 to point(133, 314)
      swapPlaybackScreen("playback dot")
      updateCamera()
      set gAutoInUse to 0
    end if
  end if
end

on autoButton whichButton
  if legalButton(whichButton) then
    set gAutomated to 0
    set gPlaying to 1
    set the timeoutScript to "randomClip"
    set gAutoInUse to 1
    if whichButton < 48 then
      store([3, 4, 11, 12, gFloatingSprite, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38])
    end if
    setProp(3, 4, "puppet", 1)
    setProp(3, 4, "locV", -500)
    puppetSprite(gFloatingSprite, 1)
    set the locV of sprite gFloatingSprite to -500
    setProp(11, 12, "visibility", 0)
    setProp(17, 39, "puppet", 1)
    setProp(17, 39, "locV", -500)
    swapPlaybackScreen("auto playback ")
    randomClip()
  end if
end

on newButton whichButton
  if legalButton(whichButton) then
    restoreControl()
    set gAutomated to 0
    if the optionDown then
      restoreTime()
    else
      resetTime()
    end if
    setProp(3, 4, "visibility", 0)
    removeFloating()
    setProp(17, 21, "puppet", 0)
    setProp(23, 29, "puppet", 0)
    setProp(17, 21, "visibility", 1)
    setProp(23, 29, "visibility", 0)
    setProp(11, 12, "visibility", 1)
    setProp(31, 38, "visibility", 1)
    set the puppet of sprite 32 to 0
    set the visible of sprite 32 to 1
    swapPlaybackScreen("playback dot")
    set gWhichMovie to 1
    set gWhichClip to 1
    go(".00")
    returnSlider()
  end if
end

on saveButton whichButton
  if legalButton(whichButton, 1) then
    set the movieRate of sprite gMovieSprite to 0
    updateStage()
    storeStopTime(the movieTime of sprite gMovieSprite)
    set adjustedTimeCodes to sortTimeCodes()
    if count(adjustedTimeCodes) > 0 then
      writeDataFile(adjustedTimeCodes)
    end if
    storeStartTime(the movieTime of sprite gMovieSprite)
    set the movieRate of sprite gMovieSprite to 1
    updateStage()
  end if
end

on loadButton whichButton
  if legalButton(whichButton, 1) then
    if the type of sprite gMovieSprite > 0 then
      set the movieRate of sprite gMovieSprite to 0
      updateStage()
    end if
    readDataFile()
    if gAutomated = 1 then
      updateCamera()
      restoreControl()
      set gStaring to 0
      returnSlider()
      delayFor(30)
      if gVR = 0 then
        if the frame < label(".10") then
          go(".10")
        end if
      end if
      setProp(11, 12, "visibility", 0)
      setProp(31, 37, "visibility", 1)
      starButton(34)
    end if
  end if
end

on fullScreenButton whichButton
  if developersKey() then
    checkClickOnMovieSprite(the left of sprite gMovieSprite, the right of sprite gMovieSprite)
  else
    set gFullScreen to 1
    set puppet33 to the puppet of sprite 33
    set puppet34 to the puppet of sprite 34
    set the movieRate of sprite gMovieSprite to 0
    updateStage()
    store([gFloatingSprite])
    setProp(3, 4, "locV", -500)
    setProp(3, 4, "visibility", 0)
    removeFloating()
    updateStage()
    setProp(1, gFloatingSprite, "puppet", 0)
    setProp(17, 48, "puppet", 0)
    if gAutoInUse = 1 then
      set the visible of sprite 40 to 1
    else
      set the visible of sprite 40 to 0
    end if
    updateStage()
    if gVR = 0 then
      go("." & gWhichMovie & gFullScreen)
    else
      go("vr." & gWhichMovie & gFullScreen)
    end if
    go(the frame + 1)
    puppetSprite(gSliderSprite, 1)
    puppetSprite(32, not gRecording)
    puppetSprite(33, puppet33)
    puppetSprite(34, puppet34)
    updateSlider()
    set the movieRate of sprite gMovieSprite to gPlaying
  end if
end

on smallScreen whichButton
  if developersKey() then
    checkClickOnMovieSprite(the left of sprite gMovieSprite, the right of sprite gMovieSprite)
  else
    set gFullScreen to 0
    set puppet33 to the puppet of sprite 33
    set puppet34 to the puppet of sprite 34
    restore([gFloatingSprite])
    setProp(17, 48, "puppet", 0)
    if gAutoInUse = 1 then
      setProp(17, 48, "visibility", 0)
    else
      setProp(1, gFloatingSprite, "puppet", 0)
    end if
    advanceNewFrame()
    puppetSprite(gSliderSprite, 1)
    puppetSprite(32, not gRecording)
    puppetSprite(33, puppet33)
    puppetSprite(34, puppet34)
    go(marker(1))
    updateCamera()
    set the movieTime of sprite gMovieSprite to the movieTime of sprite gMovieSprite
    updateStage()
    updateSlider()
    set the movieRate of sprite gMovieSprite to gPlaying
  end if
end

on exitButton whichButton
  if legalButton(whichButton) then
    stopAllQT()
    ClosePanoMovie()
    CloseNavMovie()
    restoreControl()
    setProp(1, gFloatingSprite, "puppet", 0)
    setProp(11, 12, "visibility", 1)
    setProp(17, 48, "puppet", 0)
    ClosePanoMovie()
    CloseNavMovie()
    go("Intro")
    unLoad()
    unLoadCast()
    preLoadCast("WindLoop.AIF")
    preLoadCast("MasturMu.AIF")
    set gReturning to 1
  end if
end

on quitButton whichButton
  if legalButton(whichButton) then
    stopAllQT()
    restoreControl()
    setProp(1, gFloatingSprite, "puppet", 0)
    setProp(11, 12, "visibility", 1)
    setProp(17, 48, "puppet", 0)
    go("Quit")
  end if
end

on vrButton whichButton
  if legalButton(whichButton) then
    ClosePanoMovie()
    CloseNavMovie()
    set gVR to 1
    setProp(1, gFloatingSprite, "puppet", 0)
    setProp(17, 48, "puppet", 0)
    setProp(23, 24, "visibility", 0)
    setProp(26, 29, "visibility", 0)
    go("vr girl")
  end if
end

on toysButton whichButton
  if legalButton(whichButton) then
    ClosePanoMovie()
    CloseNavMovie()
    set oldVis to the visible of sprite 23
    setProp(23, 24, "visibility", not oldVis)
    setProp(26, 29, "visibility", not oldVis)
    go(the frame - 1)
    go(the frame + 1)
  end if
end

on blankButton whichButton
  if legalButton(whichButton) then
    nothing()
  end if
end

on recordButton whichButton
  if legalButton(whichButton) then
    puppetSprite(whichButton, gRecording)
    set gRecording to not gRecording
    set the castNum of sprite whichButton to the number of cast ("recordButton, " & gRecording)
    if gRecording = 1 then
      storeStartTime(the movieTime of sprite gMovieSprite)
    else
      storeStopTime(the movieTime of sprite gMovieSprite)
    end if
  end if
  setProp(11, 12, "visibility", 1)
  set the visible of sprite 34 to 1
  updateStage()
end

on playButton whichButton
  if legalButton(whichButton) then
    if QT(gMovieSprite) then
      puppetSprite(whichButton, gPlaying)
      set gPlaying to not gPlaying
      puppetSprite(whichButton + 1, 1)
      set the visible of sprite (whichButton - 1) to not gAutomated
      set the castNum of sprite whichButton to the number of cast ("playButton, " & gPlaying)
      if gVR = 0 then
        set the castNum of sprite (whichButton + 1) to the number of cast "starButton, 0"
      end if
      set the movieRate of sprite gMovieSprite to 0
      updateStage()
      if gPlaying = 1 then
        if gStaring > 0 then
          set gStaring to 0
          set gAutomated to 0
          set gOldWhichMovie to gWhichMovie
          set gOldWhichClip to gWhichClip
          setProp(11, 12, "visibility", 1)
          setProp(17, 21, "visibility", 1)
          setProp(23, 29, "visibility", 0)
          updateCamera()
          setProp(3, 4, "visibility", 1)
          setProp(13, gFloatingSprite, "visibility", 1)
          set gDontReturnTo0 to 1
          advanceClip(gWhichClip)
        end if
      else
        if gStaring > 0 then
          set gStaring to gStaring + 1
        end if
      end if
      set the movieRate of sprite gMovieSprite to 1
      updateStage()
    end if
  end if
end

on starButton whichButton
  if legalButton(whichButton) then
    if QT(gMovieSprite) then
      if gRecording = 1 then
        storeStopTime(the movieTime of sprite gMovieSprite)
      end if
      set adjustedTimeCodes to sortTimeCodes()
      if count(adjustedTimeCodes) = 0 then
        set adjustedTimeCodes to gLoadedTimeCodes
        if count(adjustedTimeCodes) = 0 then
          exit
        end if
      end if
      set gAutomated to 1
      setProp(11, 12, "visibility", 0)
      if gStaring < 1 then
        returnSlider()
        updateStage()
        set gDontMessWithTheSlider to 1
        checkClickOnMovieSprite(133, 133)
        set gDontMessWithTheSlider to 0
      end if
      set the movieRate of sprite gMovieSprite to 0
      updateStage()
      setStar(whichButton)
      set starPlay to the result
      set the timeoutScript to "nothing"
      if gStaring = 1 then
        set gOldWhichMovie to gWhichMovie
        set gOldWhichClip to gWhichClip
        if adjustedTimeCodes <> gLoadedTimeCodes then
          set gAutomated to 0
        end if
        if the locH of sprite gSliderSprite > 133 then
          returnSlider()
        end if
        set adjustedTimeCodes to sortTimeCodes()
        if checkTimeCodes(adjustedTimeCodes) = 0 then
          nothing()
        else
          set gAutomated to 1
          set gWhichAutomatedClip to 1
          correlateSliderPositionsToMovieTime()
          set gAutomatedTimes to []
          advanceAutomatedMovie()
          set the movieTime of sprite gMovieSprite to gStartTime
        end if
      else
        if the movieRate of sprite gMovieSprite = 0 then
          set the movieRate of sprite gMovieSprite to 1
          updateStage()
        else
          storeStartTime(the movieTime of sprite gMovieSprite)
        end if
      end if
      updateCamera()
    end if
  end if
end

on setStar whichButton
  set gRecording to 0
  set gStaring to gStaring + 1
  set starPlay to (gStaring mod 2) = 0
  set gPlaying to not starPlay
  puppetSprite(whichButton - 1, 1)
  puppetSprite(whichButton, starPlay)
  set the visible of sprite (whichButton - 2) to not gStaring
  set the castNum of sprite (whichButton - 1) to the number of cast "playButton, 0"
  set the castNum of sprite whichButton to the number of cast ("starButton, " & starPlay)
  return starPlay
end

on returnSlider
  set sliderLoc to the locH of sprite gSliderSprite
  if gFullScreen = 0 then
    set minH to 133
  else
    set minH to 234
  end if
  repeat with x = sliderLoc down to minH
    set x to x - 10
    if x < minH then
      set x to minH
    end if
    set the locH of sprite gSliderSprite to x
    updateStage()
  end repeat
end

on swingPyramid
  SwingPanoMovie("4.799", "0", "44.0", 3, 1, "0")
end

on swingShip
  SwingPanoMovie("1", "0", "44.0", 3, 1, "0")
end

on jumpIntroWindows
  reconcileText()
  if gPanoMovieID <> EMPTY then
    set gVR.NodeID to "33"
    SetPanoNode(gVR.NodeID, 0)
  end if
  set gVR.HPanAngle to "0"
  set gVR.VPanAngle to "0"
  set gVR.ZoomAngle to "44.0"
  set gVR.Quality to "0"
  SetPanoMovieView(gVR.HPanAngle, gVR.VPanAngle, gVR.ZoomAngle, gVR.Quality)
end

on jumpPyramid
  reconcileText()
  if gPanoMovieID <> EMPTY then
    set gVR.NodeID to "38"
    SetPanoNode(gVR.NodeID, 0)
  end if
  set gVR.HPanAngle to "4.799"
  set gVR.VPanAngle to "0"
  set gVR.ZoomAngle to "44.0"
  set gVR.Quality to "0"
  SetPanoMovieView(gVR.HPanAngle, gVR.VPanAngle, gVR.ZoomAngle, gVR.Quality)
end

on jumpShip
  reconcileText()
  if gPanoMovieID <> EMPTY then
    set gVR.NodeID to "69"
    SetPanoNode(gVR.NodeID, 0)
  end if
  set gVR.HPanAngle to "0"
  set gVR.VPanAngle to "0"
  set gVR.ZoomAngle to "44.0"
  set gVR.Quality to "0"
  SetPanoMovieView(gVR.HPanAngle, gVR.VPanAngle, gVR.ZoomAngle, gVR.Quality)
end

on lookBeforeYouLeap
  if gVR = 0 then
    jumpPyramid()
  else
    jumpShip()
  end if
end

on huntvr
  repeat with x = 1 to 2000
    if the castType of cast x = #text then
      put the name of cast x
    end if
  end repeat
end
