global gMovie1TimeCodes, gMovie2TimeCodes, gMovie3TimeCodes, gMovie4TimeCodes, gDontMessWithTheSlider, gMarkerSlots, gFrames, gLabels, gPreviousTime, gStoredTime, gWhichMovie, gWhichClip, gSliderPositions, gMovieSprite, gStartTime, gStopTime, gBDrop, gVR, gFullScreen, gWhichCamera, gSliderCorrelation, gSliderCorrelationCount, gFloatingSprite, gAutomated, gAutomatedTimes, gWhichAutomatedClip, gRecording, gPlaying, gSliderSprite, gMarkers, gMinH, gMaxH, gWhichMarker, gMarker.00, gMarker.10, gMarker.20, gMarker.30, gMarker.40, gMarker.11, gMarker.21, gMarker.31, gMarker.41, gMarkervr.2, gMarkervr.3, gMarkervr.4, gMarkervr.5, gMarkervr.11, gMarkervr.21, gMarkervr.31, gMarkervr.41, gPlaybackScreen

on forceScript whichScript
  set the timeoutLapsed to the timeoutLength - 10
  set the timeoutScript to whichScript
  do(whichScript)
  delayFor(15)
  updateStage()
  set the timeoutScript to "nothing"
end

on freezeFrame whichFrame
  setProp(1, 48, "puppet", 0)
  puppetTransition(50, 0, 12)
  go(whichFrame)
  setProp(1, 48, "puppet", 1)
  puppetTransition(0)
  updateStage()
  startTimer()
end

on getMarkers
  set the soundEnabled to 0
  set returnFrame to the frame
  freezeFrame("legal")
  set markerList to [".00", ".10", ".20", ".30", ".40", ".11", ".21", ".31", ".41", "vr.2", "vr.3", "vr.4", "vr.5", "vr.11", "vr.21", "vr.31", "vr.41"]
  set countMarkerList to count(markerList)
  go(".00")
  setMarkers2()
  set gMarker.00 to gMarkers
  go(".10")
  setMarkers2()
  set gMarker.10 to gMarkers
  go(".20")
  setMarkers2()
  set gMarker.20 to gMarkers
  go(".30")
  setMarkers2()
  set gMarker.30 to gMarkers
  go(".40")
  setMarkers2()
  set gMarker.40 to gMarkers
  go(".11")
  setMarkers2()
  set gMarker.11 to gMarkers
  go(".21")
  setMarkers2()
  set gMarker.21 to gMarkers
  go(".31")
  setMarkers2()
  set gMarker.31 to gMarkers
  go(".41")
  setMarkers2()
  set gMarker.41 to gMarkers
  go("vr.2")
  setMarkers2()
  set gMarkervr.2 to gMarkers
  go("vr.3")
  setMarkers2()
  set gMarkervr.3 to gMarkers
  go("vr.4")
  setMarkers2()
  set gMarkervr.4 to gMarkers
  go("vr.5")
  setMarkers2()
  set gMarkervr.5 to gMarkers
  go("vr.11")
  setMarkers2()
  set gMarkervr.11 to gMarkers
  go("vr.21")
  setMarkers2()
  set gMarkervr.21 to gMarkers
  go("vr.31")
  setMarkers2()
  set gMarkervr.31 to gMarkers
  go("vr.41")
  setMarkers2()
  set gMarkervr.41 to gMarkers
  repeat while the timer < 120
    nothing()
  end repeat
  freezeFrame("logos")
  preLoadCast("VRScreen.MOV")
  preLoadCast("Pyramid.MOV")
  preLoadCast("Ship.MOV")
  preLoadCast("WindLoop.AIF")
  preLoadCast("MasturMu.AIF")
  repeat while the timer < 300
    nothing()
  end repeat
  setProp(1, 48, "puppet", 0)
  if returnFrame <= label("begin") then
    go("begin")
  else
    go(returnFrame)
  end if
  go(the frame)
  set the soundEnabled to 1
end

on getMarkers2
  set the soundEnabled to 0
  setProp(1, 48, "visibility", 0)
  updateStage()
  set returnFrame to the frame
  set markerList to [".00", ".10", ".20", ".30", ".40", ".11", ".21", ".31", ".41", "vr.2", "vr.3", "vr.4", "vr.5", "vr.11", "vr.21", "vr.31", "vr.41"]
  set countMarkerList to count(markerList)
  repeat with x = 1 to countMarkerList
    set whichMarker to getAt(markerList, x)
    go(whichMarker)
    set gMarkers to []
    repeat with y = 1 to 12
      append(gMarkers, marker(y))
    end repeat
    forceScript("set gMarker" & whichMarker & "=gMarkers")
  end repeat
  go(returnFrame)
  setProp(1, 48, "visibility", 1)
  updateStage()
  set the soundEnabled to 1
end

on setMarkers
  if gAutomated = 0 then
    setMarkers2()
    exit
  else
    set markers to 0
    do("set markers=gMarker" & gWhichMarker)
    if not listp(markers) then
      setMarkers2()
      exit
    else
      if count(markers) < 1 then
        setMarkers2()
        exit
      else
        set gMarkers to markers
        exit
      end if
    end if
  end if
end

on setMarkers2
  set gMarkers to []
  repeat with x = 1 to 12
    append(gMarkers, marker(x))
  end repeat
  set gMarker0 to gMarkers
end

on advanceNewFrame
  if gVR = 0 then
    set gWhichMarker to "." & gWhichMovie & gFullScreen
  else
    set gWhichMarker to "vr." & gWhichMovie
  end if
  go(gWhichMarker)
  setMarkers()
end

on advanceAutomatedMovie
  if gWhichAutomatedClip < 1 then
    set gWhichAutomatedClip to 1
  end if
  set timeCodeX to getAt(gAutomatedTimes, gWhichAutomatedClip)
  set gWhichMovie to getAt(timeCodeX, 1)
  set numberOfClips to 0
  do("set numberOfClips=count ( gMovie" & gWhichMovie & "TimeCodes )")
  set gWhichClip to getAt(timeCodeX, 2)
  set gWhichClip to checkRange(gWhichClip, 1, numberOfClips)
  set gWhichCamera to getAt(timeCodeX, 3)
  if gWhichCamera <> "B" then
    set gWhichCamera to "A"
  end if
  set gStartTime to getAt(timeCodeX, 4)
  set gStopTime to getAt(timeCodeX, 5)
  set gMinH to getAt(timeCodeX, 6)
  set gMaxH to getAt(timeCodeX, 7)
  swapPlaybackScreen("fantasave playback")
  set the movieTime of sprite gMovieSprite to gStartTime
  advanceNewFrame()
  go(marker(1))
end

on swapPlaybackScreen whichCast
  if gPlaybackScreen <> whichCast then
    set gPlaybackScreen to whichCast
    set the picture of cast "playback screen" to the picture of cast whichCast
    if whichCast = "fantasave playback" then
      setProp(17, 29, "puppet", 0)
      setProp(17, 29, "visibility", 0)
    end if
  end if
end

on checkMovieTime
  if the movieTime of sprite gMovieSprite < gStartTime then
    set the movieRate of sprite gMovieSprite to 0
    updateStage()
    set the movieTime of sprite gMovieSprite to gStartTime
    set the movieRate of sprite gMovieSprite to gPlaying
    updateStage()
    exit
  else
    if the movieTime of sprite gMovieSprite < gStopTime then
      exit
    else
      set the movieRate of sprite gMovieSprite to 0
      updateStage()
      if gAutomated = 1 then
        set gWhichAutomatedClip to gWhichAutomatedClip + 1
        if gWhichAutomatedClip > (count(gAutomatedTimes) - 1) then
          set gWhichAutomatedClip to 1
        end if
        advanceAutomatedMovie()
        set the movieTime of sprite gMovieSprite to gStartTime
        updateStage()
        exit
      else
        storeStopTime(gStopTime)
        storeStartTime(gStartTime)
        set the movieTime of sprite gMovieSprite to gStartTime
        updateStage()
        set the movieRate of sprite gMovieSprite to gPlaying
        updateStage()
        exit
      end if
    end if
  end if
end

on checkClickOnMovieSprite leftSide, rightSide
  if the mouseV < (the bottom of sprite gMovieSprite - 5) then
    exit
  end if
  set oldMovieRate to the movieRate of sprite gMovieSprite
  set the movieRate of sprite gMovieSprite to 0
  updateStage()
  if gAutomated = 1 then
    correlateSliderPositionsToMovieTime()
    if gSliderCorrelationCount = 0 then
      set the movieRate of sprite gMovieSprite to oldMovieRate
      exit
    end if
  end if
  set thisClipDuration to gStopTime - gStartTime
  storeStopTime(the movieTime of sprite gMovieSprite)
  set minH to 1
  if voidp(leftSide) then
    set leftSide to the left of sprite gMovieSprite
  end if
  if voidp(rightSide) then
    set rightSide to the right of sprite gMovieSprite
  end if
  set maxH to rightSide - leftSide
  if gDontMessWithTheSlider = 1 then
    set timeCodeX to getAt(gSliderCorrelation, 1)
  else
    set userSlide to 0
    repeat while the stillDown
      set userSlide to 1
      updateSlider2(thisClipDuration, leftSide, minH, maxH)
    end repeat
    set timeCodeX to the result
  end if
  if timeCodeX > 0 then
    set whichMovie to getAt(timeCodeX, 1)
    if gWhichMovie <> whichMovie then
      set gWhichMovie to whichMovie
    end if
    set gWhichClip to getAt(timeCodeX, 2)
    set gWhichCamera to getAt(timeCodeX, 3)
    if gWhichCamera <> "B" then
      set gWhichCamera to "A"
    end if
    set lMovieTime to getAt(timeCodeX, 4)
    set gWhichAutomatedClip to getAt(timeCodeX, 5)
    set limitsX to getAt(gAutomatedTimes, gWhichAutomatedClip)
    set gStartTime to getAt(limitsX, 4)
    set gStopTime to getAt(limitsX, 5)
    set gMinH to getAt(limitsX, 6)
    set gMaxH to getAt(limitsX, 7)
  end if
  storeStartTime(the movieTime of sprite gMovieSprite)
  set the movieRate of sprite gMovieSprite to oldMovieRate
end

on updateSlider
  if the movieRate of sprite gMovieSprite <> gPlaying then
    if not developersKey() then
      set the movieRate of sprite gMovieSprite to gPlaying
    end if
  end if
  if gAutomated = 0 then
    set minH to 133
    set maxH to 333
  else
    set minH to gMinH
    set maxH to gMaxH
  end if
  set minH to checkRange(minH, 133, 333)
  set maxH to checkRange(maxH, 133, 333)
  set thisClipDuration to gStopTime - gStartTime
  set thisClipDuration to checkRange(thisClipDuration, 0.001, thisClipDuration)
  set thePercentage to (the movieTime of sprite gMovieSprite - gStartTime) * 1.0 / thisClipDuration
  set sliderPosition to ((maxH - minH) * thePercentage) + minH
  set sliderPosition to checkRange(sliderPosition, minH, maxH)
  setSlider(sliderPosition)
end

on updateSlider2 thisClipDuration, leftSide, minH, maxH
  if maxH <= 0 then
    set maxH to 0.001
    set thePercentage to leftSide
  else
    set thePercentage to the mouseH - leftSide
  end if
  set thePercentage to checkRange(thePercentage, minH, maxH)
  set timeCodeX to 0
  if gAutomated = 0 then
    set the movieTime of sprite gMovieSprite to gStartTime + (thisClipDuration * (thePercentage * 1.0 / maxH))
  else
    set whichPosition to integer(gSliderCorrelationCount * (thePercentage * 1.0 / maxH))
    set whichPosition to checkRange(whichPosition, 1, gSliderCorrelationCount)
    set timeCodeX to getAt(gSliderCorrelation, whichPosition)
    set lMovieTime to getAt(timeCodeX, 4)
    set the movieTime of sprite gMovieSprite to lMovieTime
  end if
  set sliderPosition to 133 + ((333 - 133) * (thePercentage * 1.0 / maxH))
  set sliderPosition to checkRange(sliderPosition, 133, 333)
  puppetSprite(gSliderSprite, 1)
  if maxH > 0.001 then
    setSlider(sliderPosition)
  end if
  return timeCodeX
end

on setSlider sliderPosition
  if gDontMessWithTheSlider <> 1 then
    if the locV of sprite gSliderSprite > 0 then
      if gFullScreen = 0 then
        set the loc of sprite gSliderSprite to point(sliderPosition, 314)
      else
        set the loc of sprite gSliderSprite to point(sliderPosition + 101, 463)
      end if
      updateStage()
    end if
  end if
end
