global gPanoMovieID, gTestCallbackFactory

on exitFrame
  if the machineType = 256 then
    if objectp(gPanoMovieObj) then
      if the hilite of cast "MouseOverHandler Check" then
        gPanoMovieObj(mSetMouseOverCallback, gTestCallbackFactory, "TestMouseOverHandler")
      else
        gPanoMovieObj(mSetMouseOverCallback, gTestCallbackFactory, EMPTY)
      end if
      if the hilite of cast "RolloverHotSpotHandler Check" then
        gPanoMovieObj(mSetRolloverCallback, gTestCallbackFactory, "TestRolloverHotSpotHandler")
      else
        gPanoMovieObj(mSetRolloverCallback, gTestCallbackFactory, EMPTY)
      end if
      if the hilite of cast "MouseDownHandler Check" then
        gPanoMovieObj(mSetMouseDownCallback, gTestCallbackFactory, "TestMouseDownHandler")
      else
        gPanoMovieObj(mSetMouseDownCallback, gTestCallbackFactory, EMPTY)
      end if
      if the hilite of cast "PanZoomStartHandler Check" then
        gPanoMovieObj(mSetPanZoomStartCallback, gTestCallbackFactory, "TestPanZoomStartHandler")
      else
        gPanoMovieObj(mSetPanZoomStartCallback, gTestCallbackFactory, EMPTY)
      end if
      if the hilite of cast "MouseStillDownHandler Check" then
        gPanoMovieObj(mSetMouseStillDownCallback, gTestCallbackFactory, "TestMouseStillDownHandler")
      else
        gPanoMovieObj(mSetMouseStillDownCallback, gTestCallbackFactory, EMPTY)
      end if
      if the hilite of cast "NodeLeaveHandler Check" then
        gPanoMovieObj(mSetNodeLeaveCallback, gTestCallbackFactory, "TestNodeLeaveHandler")
      else
        gPanoMovieObj(mSetNodeLeaveCallback, gTestCallbackFactory, EMPTY)
      end if
      exit
    end if
  else
    if gPanoMovieID <> EMPTY then
      SetupHandler("MouseOverHandler")
      SetupHandler("RolloverHotSpotHandler")
      SetupHandler("MouseDownHandler")
      SetupHandler("PanZoomStartHandler")
      SetupHandler("MouseStillDownHandler")
      SetupHandler("NodeLeaveHandler")
      exit
    end if
  end if
  beep()
end
